diff -Nacr stunnel-3.8.orig/ssl.c stunnel-3.8/ssl.c
*** stunnel-3.8.orig/ssl.c	Fri Feb 18 10:26:48 2000
--- stunnel-3.8/ssl.c	Fri Jul 21 13:57:59 2000
***************
*** 373,525 ****
      ; /* ANSI C compiler needs it */
  }
  
! static int transfer(SSL *ssl, int sock_fd) /* transfer data */
  {
!     fd_set rd_set, wr_set;
!     int num, fdno, ssl_fd, ssl_bytes, sock_bytes, retval;
!     char sock_buff[BUFFSIZE], ssl_buff[BUFFSIZE];
!     int sock_ptr, ssl_ptr, sock_open, ssl_open;
! #if defined FIONBIO && defined USE_NBIO
!     unsigned long l;
  #endif
  
!     ssl_fd=SSL_get_fd(ssl);
!     fdno=(ssl_fd>sock_fd ? ssl_fd : sock_fd)+1;
!     sock_ptr=0;
!     ssl_ptr=0;
!     sock_open=1;
!     ssl_open=1;
!     sock_bytes=0;
!     ssl_bytes=0;
  
  #if defined FIONBIO && defined USE_NBIO
!     l=1; /* ON */
!     if(ioctlsocket(sock_fd, FIONBIO, &l)<0)
!         sockerror("ioctlsocket (sock)"); /* non-critical */
!     if(ioctlsocket(ssl_fd, FIONBIO, &l)<0)
!         sockerror("ioctlsocket (ssl)"); /* non-critical */
!     log(LOG_DEBUG, "Sockets set to non-blocking mode");
  #endif
  
!     while((sock_open||sock_ptr) && (ssl_open||ssl_ptr)) {
          FD_ZERO(&rd_set);
!         if(sock_open && sock_ptr<BUFFSIZE) /* can read from socket */
!             FD_SET(sock_fd, &rd_set);
!         if(ssl_open && ssl_ptr<BUFFSIZE) /* can read from SSL */
!             FD_SET(ssl_fd, &rd_set);
          FD_ZERO(&wr_set);
!         if(sock_open && ssl_ptr) /* can write to socket */
!             FD_SET(sock_fd, &wr_set);
!         if(ssl_open && sock_ptr) /* can write to SSL */
!             FD_SET(ssl_fd, &wr_set);
          if(select(fdno, &rd_set, &wr_set, NULL, NULL)<0) {
              sockerror("select");
!             goto error;
!         }
!         if(sock_open && FD_ISSET(sock_fd, &rd_set)) {
!             num=readsocket(sock_fd, sock_buff+sock_ptr, BUFFSIZE-sock_ptr);
!             if(num<0 && errno==ECONNRESET) {
!                 log(LOG_NOTICE, "IPC reset (child died)");
!                 break; /* close connection */
!             }
!             if (num < 0 && errno != EIO) {
!                 sockerror("read");
!                 goto error;
!             } else if (num > 0) {
!                 sock_ptr += num;
!             } else { /* close */
!                 log(LOG_DEBUG, "Socket closed on read");
!                 sock_open = 0;
!             }
!         }
!         if(ssl_open && FD_ISSET(ssl_fd, &rd_set)) {
!             num=SSL_read(ssl, ssl_buff+ssl_ptr, BUFFSIZE-ssl_ptr);
!             switch(SSL_get_error(ssl, num)) {
!             case SSL_ERROR_NONE:
!                 ssl_ptr+=num;
!                 break;
!             case SSL_ERROR_WANT_WRITE:
!             case SSL_ERROR_WANT_READ:
!             case SSL_ERROR_WANT_X509_LOOKUP:
!                 log(LOG_DEBUG, "SSL_read returned WANT_ - retry");
!                 break;
!             case SSL_ERROR_SYSCALL:
!                 if(num) { /* not EOF */
!                     sockerror("SSL_read (socket)");
!                     goto error;
!                 }
!             case SSL_ERROR_ZERO_RETURN:
!                 log(LOG_DEBUG, "SSL closed on read");
!                 ssl_open=0;
!                 break;
!             case SSL_ERROR_SSL:
!                 sslerror("SSL_read");
!                 goto error;
!             }
!         }
!         if(sock_open && FD_ISSET(sock_fd, &wr_set)) {
!             num=writesocket(sock_fd, ssl_buff, ssl_ptr);
!             if(num<0) {
!                 sockerror("write");
!                 goto error;
!             }
!             if(num) {
!                 memcpy(ssl_buff, ssl_buff+num, ssl_ptr-num);
!                 ssl_ptr-=num;
!                 sock_bytes+=num;
!             } else { /* close */
!                 log(LOG_DEBUG, "Socket closed on write");
!                 sock_open=0;
!             }
!         }
!         if(ssl_open && FD_ISSET(ssl_fd, &wr_set)) {
!             num=SSL_write(ssl, sock_buff, sock_ptr);
!             switch(SSL_get_error(ssl, num)) {
!             case SSL_ERROR_NONE:
!                 memcpy(sock_buff, sock_buff+num, sock_ptr-num);
!                 sock_ptr-=num;
!                 ssl_bytes+=num;
!                 break;
!             case SSL_ERROR_WANT_WRITE:
!             case SSL_ERROR_WANT_READ:
!             case SSL_ERROR_WANT_X509_LOOKUP:
!                 log(LOG_DEBUG, "SSL_write returned WANT_ - retry");
!                 break;
!             case SSL_ERROR_SYSCALL:
!                 if(num) { /* not EOF */
!                     sockerror("SSL_write (socket)");
!                     goto error;
!                 }
!             case SSL_ERROR_ZERO_RETURN:
!                 log(LOG_DEBUG, "SSL closed on write");
!                 ssl_open=0;
!                 break;
!             case SSL_ERROR_SSL:
!                 sslerror("SSL_write");
!                 goto error;
!             }
          }
      }
!     retval=0;
!     goto done;
! error:
!     retval=-1;
! done:
  
  #if defined FIONBIO && defined USE_NBIO
      l=0; /* OFF */
!     if(ioctlsocket(sock_fd, FIONBIO, &l)<0)
          sockerror("ioctlsocket (sock)"); /* non-critical */
!     if(ioctlsocket(ssl_fd, FIONBIO, &l)<0)
          sockerror("ioctlsocket (ssl)"); /* non-critical */
  #endif
  
      log(LOG_NOTICE,
          "Connection %s: %d bytes sent to SSL, %d bytes sent to socket",
!         retval<0 ? "reset" : "closed", ssl_bytes, sock_bytes);
      return retval;
  }
  
  #ifndef NO_RSA
  static RSA *tmp_rsa_cb(SSL *s, int export, int keylength)
  { /* temporary RSA key callback */
--- 362,1182 ----
      ; /* ANSI C compiler needs it */
  }
  
! 
! /*	Initialize/clear Channel struct.
! **	Returns 0=problem; 1=OK.
! */
! int 	init_ch(Channel *channel)
  {
! 	if (channel == NULL)  return 0;
! 
! 	channel->open	= CHAN_OPEN;
! 	channel->ctx	= NULL;
! 	channel->ssl	= NULL;
! 	channel->fd 	= 0;
! 	channel->bytes	= 0;
! 	channel->ptr	= 0;
! 
! 	return 1;
! }
! 
! 
! void	show_sock(int s)
! {
!     struct sockaddr_in	addr, paddr;
! 	int 				addrlen, paddrlen;
! 	char				*self, *other;
! 	int 				sport, oport;
! 
!     if (getsockname(s, (struct sockaddr *) &addr, &addrlen) < 0)  {
! 		printf("show_sock(%d): getsockname failed\n", s);
! 		}
!     if (getpeername(s, (struct sockaddr *) &paddr, &paddrlen) < 0)  {
! 		printf("show_sock(%d): getpeername failed\n", s);
! 		}
! 	
! 	self = inet_ntoa(addr.sin_addr);	other = inet_ntoa(paddr.sin_addr);
! 	sport= ntohs(addr.sin_port);		oport = ntohs(paddr.sin_port);
! 
! 	if (!self)	self  = "undef";
! 	if (!other)	other = "undef";
! 
! 	printf("Socket %d (%s:%d) is connected to: %s:%d\n", s,
! 					self,sport, other,oport);
! }
! 
! 
! #define	MAX_SESS	40;
! 
! /*	Create SSL connection on (local or remote) channel to given host.
! **	Return 0:Success.
! */
! int 	new_ssl_ch(Channel *chan, char *host)
! {
! 	EVP_MD_CTX		hash_ctx;
! 	unsigned char	*sess_id;
! 	unsigned int 	len = getpid();
! 
! 	if ((!chan->ctx  &&  !(chan->ctx = context_init(host)))  ||
! 		(!chan->ssl  &&  !(chan->ssl = SSL_new(chan->ctx))))  {
!         sslerror("SSL_new");
!         return -1;
! 		}
! 	/*
! 	SSL_clear(chan->ssl);
! 	*/
! 
! #if SSLEAY_VERSION_NUMBER >= 0x0922
! 	EVP_DigestInit(&hash_ctx, EVP_get_digestbyname("ssl3-sha1"));
! 	EVP_DigestUpdate(&hash_ctx, chan->ssl, sizeof(chan));
! 	EVP_DigestUpdate(&hash_ctx, chan, sizeof(chan));
! 	EVP_DigestUpdate(&hash_ctx, &len, sizeof(len));
! 	if (!(sess_id = (unsigned char *) malloc(EVP_MD_size(hash_ctx.digest))))  {
! 		sslerror("session_id_context alloc");
! 		return -1;
! 		}
! 	EVP_DigestFinal(&hash_ctx, sess_id, &len);
!     SSL_set_session_id_context(chan->ssl, sess_id, len);
! 	free(sess_id);
  #endif
  
! #ifndef NO_KRB5
! 	if (chan->ssl->kssl_ctx)  {
! 		kssl_ctx_setstring(chan->ssl->kssl_ctx, KSSL_SERVICE, KRB5SVC);
! 		kssl_ctx_setstring(chan->ssl->kssl_ctx, KSSL_KEYTAB, KRB5KEYTAB);
! 		if (host)  kssl_ctx_setstring(chan->ssl->kssl_ctx, KSSL_SERVER, host);
! 		}
! #endif	/* NO_KRB5 */
! 
! 	return 0;
! }
! 
! 
! /*	Close any SSL channels.
! */
! void	shutdown_ssl_ch(Channel *local, Channel *remote)
! {
! 	have_cookie = 0;
! 
! 	if (local  &&  local->ssl)  {
! 		SSL_set_shutdown(local->ssl,  SSL_SENT_SHUTDOWN|SSL_RECEIVED_SHUTDOWN);
! 		SSL_free(local->ssl);
! 		local->ssl = NULL;
! 		local->ctx = NULL;
! 		}
! 	if (remote  &&  remote->ssl)  {
! 		SSL_set_shutdown(remote->ssl, SSL_SENT_SHUTDOWN|SSL_RECEIVED_SHUTDOWN);
! 		SSL_free(remote->ssl);
! 		remote->ssl = NULL;
! 		remote->ctx = NULL;
! 		}
!     ERR_remove_state(0);
! }
! 
! 
! /*	Set SSL fd and do SSL_connect.
! **	Return 0:Success.
! */
! int 	connect_ssl_ch(Channel *chan, char *hp)
! {
! 	if (!chan->fd  &&  create_remote_sock(chan, hp))  {
! 		sslerror("ssl create remote sock");
! 		return 1;
! 		}
! 	SSL_set_fd(chan->ssl, chan->fd);
! 	SSL_set_connect_state(chan->ssl);
! 	if (SSL_connect(chan->ssl) <= 0)  {
! 		sslerror("SSL_connect");
! 		return 1;
! 		}
! 	/*
! 	print_cipher(chan->ssl);
! 	*/
! 
! 	return 0;
! }
! 
! /*	Set SSL fd and do SSL_accept.
! **	Return 0:Success.
! */
! int 	accept_ssl_ch(Channel *chan)
! {
! 	SSL_set_fd(chan->ssl, chan->fd);
! 	SSL_set_accept_state(chan->ssl);
! 	if (SSL_accept(chan->ssl) <= 0)  {
! 		sslerror("SSL_accept");
! 		return 1;
! 		}
! 	/*
! 	print_cipher(chan->ssl);
! 	*/
! 
! 	return 0;
! }
! 
! /*	Do SSL read on given channel, return number of bytes read through *numptr.
! **	Return 0:Success
! */
! int 	rd_ssl_ch(Channel *chan, int *numptr)
! {
! 	*numptr = SSL_read(chan->ssl, chan->buff + chan->ptr, BUFFSIZE - chan->ptr);
! 
! 	switch (SSL_get_error(chan->ssl, *numptr))  {
! 		case SSL_ERROR_NONE:
! 			chan->ptr += *numptr;
! 			break;
! 		case SSL_ERROR_WANT_WRITE:
! 		case SSL_ERROR_WANT_READ:
! 		case SSL_ERROR_WANT_X509_LOOKUP:
! 			log(LOG_DEBUG, "SSL_read returned WANT_ - retry");
! 			break;
! 		case SSL_ERROR_SYSCALL:
! 			if (*numptr)  { 	/* not EOF */
! 				sockerror("SSL_read (socket)");
! 				return -1;
! 			}
! 		case SSL_ERROR_ZERO_RETURN:
! 			log(LOG_DEBUG, "SSL closed on read");
! 			chan->open = 0;
! 			break;
! 		case SSL_ERROR_SSL:
! 		default:
! 			sslerror("SSL_read");
! 			return -1;
! 		}
! 
! 	return 0;
! }
! 
! /*	Do SSL write on given channel, return #bytes written through *numptr.
! **	Return 0:Success
! */
! int 	wr_ssl_ch(Channel *from, Channel *to, int *numptr)
! {
! 	*numptr = SSL_write(to->ssl, from->buff, from->ptr);
! 
! 	switch (SSL_get_error(to->ssl, *numptr)) {
! 		case SSL_ERROR_NONE:
! 			memcpy(from->buff, from->buff + *numptr, from->ptr - *numptr);
! 			from->ptr -= *numptr;
! 			to->bytes += *numptr;
! 			break;
! 		case SSL_ERROR_WANT_WRITE:
! 		case SSL_ERROR_WANT_READ:
! 		case SSL_ERROR_WANT_X509_LOOKUP:
! 			log(LOG_DEBUG, "SSL_write returned WANT_ - retry");
! 			break;
! 		case SSL_ERROR_SYSCALL:
! 			if (*numptr)  { /* not EOF */
! 				sockerror("SSL_write (socket)");
! 				return -1;
! 				}
! 		case SSL_ERROR_ZERO_RETURN:
! 			log(LOG_DEBUG, "SSL closed on write");
! 			to->open = 0;
! 			break;
! 		case SSL_ERROR_SSL:
! 		default:
! 			sslerror("SSL_write");
! 			return -1;
! 		}
! 
! 	return 0;
! }
! 
! 
! /*	Create and connect any local/remote sockets or ssl connections,
! **	as appropriate for km_mode.  KM_NORMAL mode should match original stunnel.
! **	The local socket connection should already be established.
! **	Return 0:Success.
! */
! int 	connect_ch(Channel *local, Channel *remote, int km_mode, char *hp)
! {
! 	char	*cp, host[MAX_HP+1];
! 	int 	rc = 0;
! 
! 	cp = (km_mode == KM_NORMAL)? options.servname: hp;
! 	if (strlen(cp) >= MAX_HP)  {
! 		sockerror("host name overflow");
! 		return -1;
! 		}
! 	strcpy(host, cp);
! 	cp = strrchr(host, (km_mode == KM_NORMAL)? '.': ':');
! 	if (cp)  *cp = '\0';
! 
! 	switch (km_mode)  {
! 
! 		case KM_NORMAL:
! 				/*	Add remote ssl connection to options.servname		*/
! 				new_ssl_ch(remote, host);
! 
! 				if (options.option & OPT_CLIENT)  {
! 					if (!hp  ||  !strlen(hp))  {
! 						hp = (char *) options.localnames;
! 						if (!hp  ||  !strlen(hp))  hp = "localhost";
! 						snprintf(host, MAX_HP, "%s:%d", hp, options.localport);
! 						hp = host;
! 						}
! 					if (connect_ssl_ch(remote, hp))  return -1;
! 					}
! 				else  {
! 					if (accept_ssl_ch(remote))   return -1;
! 					}
! 				break;
! 
! 		case KM_KSSL_MITM:
! 				/*	Add remote ssl connection to host,
! 				**	Add local ssl connection and use in place of local->fd
! 				*/
! 				rc = new_ssl_ch(remote, host);
! 
! 				/* VRS 20000324 late: maybe blame existing remote->fd = 10 so...
! 				   if (remote->fd)  { closesocket(remote->fd); remote->fd=0; }
! 				*/
! 				  remote->fd = 0;
! 				if (connect_ssl_ch(remote, hp))  return -1;
! 
! 				if (! fake_CONNECT(local))  return -1;
! 
! 				new_ssl_ch(local, NULL);
! 				if (accept_ssl_ch(local))  return -1;
! 
! 				break;
! 
! 		case KM_LOCAL_HTTPS:
! 				/*	Add remote sock connection to host					*/
! 				if (create_remote_sock(remote, hp))  {
! 					sockerror("local https");
! 					return -1;
! 					}
! 
! 				if (! fake_CONNECT(local))  return -1;
! 				break;
! 
! 		case KM_REMOTE_HTTPS:
! 				/*	Add remote sock connection to host					*/
! 				if (create_remote_sock(remote, hp))  {
! 					sockerror("remote https");
! 					return -1;
! 					}
! 				break;
! 
! 		default:
! 				return -1;
! 				break;
! 		}
  
+ 	return 0;
+ }
+ 
+ 
+ static	fd_set	rd_set, wr_set;
+ 
+ /*	transfer data
+ */
+ static int transfer(Channel *local, Channel *remote)
+ {
+     int 	fdno;
+ 	int 	retval = 1;
+ 	int 	km_mode = KM_UNDEF;
  #if defined FIONBIO && defined USE_NBIO
!     unsigned long	l;
! #endif
! 
! #if defined FIONBIO && defined USE_NBIO
! 	l=1; /* ON */
! 	if(ioctlsocket(local->fd, FIONBIO, &l)<0)
! 		sockerror("ioctlsocket (sock)"); /* non-critical */
! 	if(ioctlsocket(remote->fd, FIONBIO, &l)<0)
! 		sockerror("ioctlsocket (ssl)"); /* non-critical */
! 	log(LOG_DEBUG, "Sockets set to non-blocking mode");
  #endif
  
!     while( retval > 0  &&
! 		(local->open||local->ptr) && (remote->open||remote->ptr))  {
! 
! 		fdno = ((remote->fd > local->fd)? remote->fd: local->fd) + 1;
! 
          FD_ZERO(&rd_set);
!         if(local->open && local->ptr<BUFFSIZE) /* can read from socket */
!             if (local->fd)  FD_SET(local->fd, &rd_set);
!         if(remote->open && remote->ptr<BUFFSIZE) /* can read from SSL */
!             if (remote->fd)  FD_SET(remote->fd, &rd_set);
! 
          FD_ZERO(&wr_set);
!         if(local->open && remote->ptr) /* can write to socket */
!             if (local->fd)  FD_SET(local->fd, &wr_set);
!         if(remote->open && local->ptr) /* can write to SSL */
!             if (remote->fd)  FD_SET(remote->fd, &wr_set);
! 
          if(select(fdno, &rd_set, &wr_set, NULL, NULL)<0) {
              sockerror("select");
! 			retval = -1;
! 			break;
          }
+ 
+ 		if ((retval = rd_local (local, remote, &km_mode)) <= 0)  break;
+ 		if ((retval = rd_remote(local, remote, &km_mode)) <= 0)  break;
+ 		if ((retval = got_cookie(local,remote,  km_mode)) <= 0)  break;
+ 		if ((retval = wr_local (local, remote,  km_mode)) <= 0)  break;
+ 		if ((retval = wr_remote(local, remote,  km_mode)) <= 0)  break;
      }
! 
! 	have_cookie = 0;
  
  #if defined FIONBIO && defined USE_NBIO
      l=0; /* OFF */
!     if(ioctlsocket(local->fd, FIONBIO, &l)<0)
          sockerror("ioctlsocket (sock)"); /* non-critical */
!     if(ioctlsocket(remote->fd, FIONBIO, &l)<0)
          sockerror("ioctlsocket (ssl)"); /* non-critical */
  #endif
  
      log(LOG_NOTICE,
          "Connection %s: %d bytes sent to SSL, %d bytes sent to socket",
!         retval<0 ? "reset" : "closed", remote->bytes, local->bytes);
      return retval;
  }
  
+ 
+ /*	Search and destroy cookie in local stream.
+ **	Cookie should look like: "\nCookie: stunnel/kssl=4C7DD01FA175330D\n"
+ **	The search is not confined to HTTP headers;
+ **	consider this a feature to avoid leaking the random nonce ;-)
+ **	Return 1 if good cookie found, 0 otherwise.
+ */
+ int 	eat_cookie(Channel *local, char *header, char *key)
+ {
+ 	char	*found, *nonce, *next;
+ 	char	*eob = &local->buff[local->ptr] - 1;
+ 	char	backup;
+ 	int 	i = 0, taillen;
+ 	int 	rc = 0;
+ 
+ 	backup = local->buff[local->ptr];		local->buff[local->ptr] = '\0';
+ 	found = strstr(local->buff, header);	local->buff[local->ptr] = backup;
+ 	if (!found)  return 0;
+ 
+ 	found += strlen(header);				local->buff[local->ptr] = '\0';
+ 	found = strstr(found, key);				local->buff[local->ptr] = backup;
+ 	if (!found)  return 0;
+ 
+ 	nonce = found + strlen(key);
+ 	rc = (! options.cookie->nonce_len)?
+ 		 0: ! strncmp(nonce, options.cookie->nonce, options.cookie->nonce_len);
+ 
+ 	/*
+ 	**	What happens if cookie line fragmented across BUFFSIZE buffer?
+ 	**	Expect header to be truncated, possibly leaking nonce.
+ 	*/
+ 	for (next=nonce; next<eob && *next!='\n' && !isspace((int)*next); next++) ;
+ 	while (next < eob  &&  *next != '\n'  && isspace((int)*next))  next++;
+ 	taillen = local->ptr - (next - local->buff);
+ 	(void) memcpy(found, next, taillen);
+ 	local->ptr -= next - found;
+ 
+ 	/*	may trim trailing ", "
+ 	*/
+ 	if (found > local->buff  &&  *found == '\n')  {
+ 		eob = found - 1;
+ 		for (i=0;  --eob > local->buff; i++)  {
+ 			if (!isspace((int) *eob)  &&  *eob != ',')  break;
+ 			}
+ 		if (i)  {
+ 			(void) memcpy(found-1-i, found, taillen);
+ 			local->ptr -= i;
+ 			}
+ 		}
+ 
+ 	return rc;
+ }
+ 
+ 
+ /*	Error response for bad/missing auth cookie
+ */
+ const char	*badcookie_response =
+ 		"HTTP/1.0 403 Access to proxy denied\n"
+ 		"Proxy-agent: "  PROXY_VERSION  "\n"
+ 		"Content-type: text/html\n"
+ 		"Content-length: CONTLEN\n"
+ 		"\n"
+ 		"<HTML><Head><Title> Access to proxy denied</Title></Head>\n\n"
+ 		"<Body><H1> 403 Access to proxy denied</H1>\n<P>\n"
+ 		"Access to the klpstunnel proxy was rejected because \n"
+ 		"your web browser did not provide the required cookie. \n"
+ 		"Cookies are provided in the <Code> Cookie:</Code> or \n"
+ 		"<Code> Accept-Language:</Code> HTTP headers. \n"
+ 		"<P>\nPossible remedies:\n<OL>\n"
+ 		"<LI>  You must run the klpstunnel proxy <Strong>before</Strong>\n"
+ 			   "you start up your web browser\n"
+ 		"<!--"
+ 		"<LI>  You must enable cookies in your web browser\n"
+ 		"--> "
+ 		"</OL>\n"
+ 		"</Body></HTML>\n" ;
+ 
+ /*	Search for cookie in local channel, set have_cookie if good one found.
+ **	Return 1:OK if have_cookie is set, or otherwise OK.
+ **	Otherwise return -1:Fail and
+ **		o	Write error message to local channel
+ **		o	Exit proxy if failed connection attempt limit exceeded.
+ */
+ int 	got_cookie(Channel *local, Channel *remote, int km_mode)
+ {
+ 	Channel		badcookie_channel;
+ 	const int	badcookie_len = strlen(badcookie_response);
+ 	const int	com1 = strstr(badcookie_response, "<!--") - badcookie_response;
+ 	const int	com2 = strstr(badcookie_response, "--> ") - badcookie_response;
+ 	char		*cp;
+ 
+ 	/*	Always destroy cookie before sending data to remote side.
+ 	*/
+ 	if (eat_cookie(local, "\nCookie:", COOKIE_TAG "=")  &&
+ 		(options.cookie->ns_auths & AUTH_COOK))  have_cookie = 1;
+ 	if (eat_cookie(local, "\nAccept-Language:", COOKIE_TAG "-")  &&
+ 		(options.cookie->ns_auths & AUTH_LANG))  have_cookie = 1;
+ 	/*	Might should loop this in case multiple cookies in buffer;
+ 	*/
+ 
+ 	/*	Don't freak out until there's something to write to remote side.
+ 	**	This lets the CONNECT msg and response slide by without a cookie.
+ 	*/
+ 	if (!remote->open  ||  !FD_ISSET(remote->fd, &wr_set))  return 1;
+ 
+ 	if (have_cookie)  return 1;
+ 	if (!options.cookie->nonce_len)   return 1; 	/* len=0 diasbles check	*/
+ 
+ 	if (badcookie_len + 1 > BUFFSIZE)  {
+ 		fprintf(stderr, "Programming botch: "
+ 						"badcookie_response exceeds BUFFSIZE (%d)\n", BUFFSIZE);
+ 		exit(1);
+ 		}
+ 	badcookie_channel.ptr = badcookie_len;
+ 	strcpy(badcookie_channel.buff, badcookie_response);
+ 	if ((cp = strstr(badcookie_channel.buff, "CONTLEN")))  {
+ 		snprintf(cp, 7, "%-7d", strlen(cp+9));
+ 		if (strlen(cp) < 10)  cp[strlen(cp)] = '\n';
+ 		}
+ 	if (options.cookie->ns_auths & AUTH_COOK)  {
+ 		strncpy(&badcookie_channel.buff[com1], "    ", 4);
+ 		strncpy(&badcookie_channel.buff[com2], "    ", 4);
+ 		}
+ 	FD_SET(local->fd, &wr_set);
+ 	(void) wr_local (local, &badcookie_channel, km_mode);
+ 
+ 	if (remote->ssl)  {
+ 		ssl3_send_alert(remote->ssl,SSL3_AL_FATAL,SSL_AD_HANDSHAKE_FAILURE);
+ 		}
+ 
+ 	if (++options.cookie->tries > options.cookie->max_tries)  {
+ 		fprintf(stderr, "proxy exiting after %d failed connection attempts\n",
+ 				options.cookie->tries);
+ 		  /*  printf("VRS DB: should restore prefs here?\n");	*/
+ 		exit(1);
+ 		}
+ 
+ 	return -1;
+ }
+ 
+ 
+ /*	Read local channel (normally socket; ssl in kssl MitM mode)
+ **
+ **	Returns:  1:OK, 0,-1: error
+ */
+ int 	rd_local(Channel *local, Channel *remote, int *km_mode)
+ {
+ 	int 	num, retval;
+ 	char	*hp = NULL;
+ 	int 	in_connect = 0;
+ 
+ 	if (!local->open  ||  !FD_ISSET(local->fd, &rd_set))  return 1;
+ 
+ 	if (*km_mode == KM_KSSL_MITM)  {
+ 		if ((retval = rd_ssl_ch(local, &num)))  return retval;
+ 		}
+ 	else if (	*km_mode == KM_LOCAL_HTTPS	||  *km_mode == KM_NORMAL  ||
+ 				*km_mode == KM_REMOTE_HTTPS	||  *km_mode == KM_UNDEF 	)  {
+ 		num = readsocket(local->fd, local->buff+local->ptr,BUFFSIZE-local->ptr);
+ 		if (num < 0  &&  errno == ECONNRESET)  {
+ 			log(LOG_NOTICE, "IPC reset (child died)");
+ 			return 0;	/* close connection */
+ 			}
+ 		if (num < 0  &&  errno != EIO)  {
+ 			sockerror("read");
+ 			return -1;
+ 			}
+ 		else if (num > 0)  {
+ 			if (*km_mode == KM_UNDEF)  {
+ 				*km_mode = check_CONNECT(local->buff + local->ptr, &hp);
+ 				if (*km_mode == KM_LOCAL_HTTPS  ||  *km_mode == KM_KSSL_MITM) {
+ 					in_connect = 1;
+ 					}
+ 				retval = connect_ch(local, remote, *km_mode, hp);
+ 				if (retval)   return retval;
+ 				}
+ 
+ 			switch (*km_mode)  {
+ 				case KM_LOCAL_HTTPS:
+ 				case KM_KSSL_MITM:
+ 						if (in_connect)  break;		/*  else fall through	*/
+ 				case KM_REMOTE_HTTPS:
+ 				case KM_NORMAL:
+ 						local->ptr += num;
+ 						break;
+ 				default:
+ 						sockerror("check_CONNECT");
+ 						return -1;
+ 				}
+ 			}
+ 		else  { 	/* close */
+ 			log(LOG_DEBUG, "Socket closed on read");
+ 			local->open = 0;
+ 			}
+ 		}
+ 	else  {
+ 		sockerror("rd_local");
+ 		return -1;
+ 		}
+ 
+ 	return 1;
+ }
+ 
+ 
+ /*	Read remote channel (normally ssl; socket in https proxy modes)
+ **
+ **	Returns:  1:OK; 0,-1: error
+ */
+ int 	rd_remote(Channel *local, Channel *remote, int *km_mode)
+ {
+ 	int 	num, retval;
+ 
+ 	if (!remote->open  ||  !FD_ISSET(remote->fd, &rd_set))  return 1;
+ 
+ 	/*	20000428 VRS Network error dialog appears in cases where rd_local
+ 	**	fails (not ready), and we fall into rd_remote with KM_NORMAL mode.
+ 	**	Let's try disabling this and see what happens
+ 	*/
+ 	if (*km_mode == KM_UNDEF)  return 1;	/* Net Error Dialog averted? */
+ 	if (*km_mode == KM_UNDEF)  {
+ 		*km_mode = KM_NORMAL;
+ 		retval = connect_ch(local, remote, *km_mode, "");
+ 		if (retval)   return retval;
+ 		}
+ 
+ 	if (*km_mode == KM_NORMAL  ||  *km_mode == KM_KSSL_MITM)  {
+ 		if ((retval = rd_ssl_ch(remote, &num)))  return retval;
+ 		}
+ 	else if (*km_mode == KM_LOCAL_HTTPS  ||  *km_mode == KM_REMOTE_HTTPS)  {
+ 		num = readsocket(remote->fd,
+ 						 remote->buff + remote->ptr, BUFFSIZE - remote->ptr);
+ 		if (num < 0  &&  errno == ECONNRESET)  {
+ 			log(LOG_NOTICE, "IPC reset (child died)");
+ 			return 0;	/* close connection */
+ 			}
+ 		if (num < 0  &&  errno != EIO)  {
+ 			sockerror("read");
+ 			return -1;
+ 			}
+ 		else if (num > 0)  {
+ 			remote->ptr += num;
+ 			}
+ 		else  { 	/* close */
+ 			log(LOG_DEBUG, "Socket closed on read");
+ 			remote->open = 0;
+ 			}
+ 		}
+ 	else  {
+ 		sockerror("rd_remote");
+ 		return -1;
+ 		}
+ 
+ 	return 1;
+ }
+ 
+ 
+ /*	Write local channel (normally socket; ssl in kssl MitM mode)
+ **
+ **	Returns:  1:OK; 0,-1: error
+ */
+ int 	wr_local(Channel *local, Channel *remote, int km_mode)
+ {
+ 	int 	num;
+ 
+ 	if (!local->open  ||  !FD_ISSET(local->fd, &wr_set))  return 1;
+ 
+ 	if (km_mode == KM_KSSL_MITM)  {
+ 		wr_ssl_ch(remote, local, &num);
+ 		}
+ 	else if (km_mode == KM_LOCAL_HTTPS  ||  km_mode == KM_REMOTE_HTTPS  ||
+ 			 km_mode == KM_NORMAL)  {
+ 		num = writesocket(local->fd, remote->buff, remote->ptr);
+ 		if (num < 0)  {
+ 			sockerror("write");
+ 			return -1;
+ 			}
+ 		if (num)  {
+ 			memcpy(remote->buff, remote->buff+num, remote->ptr-num);
+ 			remote->ptr  -= num;
+ 			local->bytes += num;
+ 			}
+ 		else  { 	/* close */
+ 			log(LOG_DEBUG, "Socket closed on write");
+ 			local->open = 0;
+ 			}
+ 		}
+ 	else  {
+ 		sockerror("wr_local");
+ 		return -1;
+ 		}
+ 
+ 	return 1;
+ }
+ 
+ 
+ /*	Write remote channel (normally ssl; socket in https proxy modes)
+ **
+ **	Returns:  1:OK; 0,-1: error
+ */
+ int 	wr_remote(Channel *local, Channel *remote, int km_mode)
+ {
+ 	int 	num, retval;
+ 
+ 	if (!remote->open  ||  !FD_ISSET(remote->fd, &wr_set))  return 1;
+ 
+ 	if (km_mode == KM_NORMAL  ||  km_mode == KM_KSSL_MITM)  {
+ 		if ((retval = wr_ssl_ch(local, remote, &num)))  return retval;
+ 		}
+ 	else if (km_mode == KM_LOCAL_HTTPS  ||  km_mode == KM_REMOTE_HTTPS)  {
+ 		num = writesocket(remote->fd, local->buff, local->ptr);
+ 		if (num < 0)  {
+ 			sockerror("write");
+ 			return -1;
+ 			}
+ 		if (num)  {
+ 			memcpy(local->buff, local->buff+num, local->ptr-num);
+ 			local->ptr	  -= num;
+ 			remote->bytes += num;
+ 			}
+ 		else  { 	/* close */
+ 			log(LOG_DEBUG, "Socket closed on write");
+ 			local->open = 0;
+ 			}
+ 		}
+ 	else  {
+ 		sockerror("wr_remote");
+ 		return -1;
+ 		}
+ 
+ 	return 1;
+ }
+ 
+ 
+ /*	Check local socket data for https "CONNECT host:port HTTP/1.0" message.
+ **	Return mode in:
+ **		KM_NORMAL, KM_KSSL_MITM, KM_LOCAL_HTTPS, KM_REMOTE_HTTPS, KM_FAULT,
+ **	and set *hp to point to static local buffer with host:port.
+ */
+ int 	check_CONNECT(const char *str, char **hp)
+ {
+ 	static char	hostport[MAX_HP+1];
+ 	int 		hstart, hplen;
+ 	char 		*cp;
+ 
+ 	hostport[0] = '\0';
+ 	*hp = hostport;
+ 
+ 	if (!(options.option & OPT_KHTTPS))  return KM_NORMAL;
+ 
+ 	if (strncmp(str, "CONNECT", 7) == 0)  {
+ 		hstart = 7 + strspn(&str[7], " \t");
+ 		hplen = strcspn(&str[hstart], " \t");
+ 		if (hplen >= MAX_HP)  return KM_FAULT;
+ 		strncpy(hostport, &str[hstart], hplen);
+ 		hostport[hplen] = '\0';
+ 		if (strchr(*hp, ':') == NULL)  return KM_FAULT;
+ 		}
+ 	else  {
+ 		return KM_NORMAL;
+ 		}
+ 
+ 	if (options.kssl_list  &&  (cp = strstr(options.kssl_list, *hp))  && 
+ 		(cp[hplen] == '\0'  ||  cp[hplen] == ','))  {
+ 		return KM_KSSL_MITM;
+ 		}
+ 	else if (options.https_proxy)  {
+ 		if (strlen(options.https_proxy) >= MAX_HP)  return KM_FAULT;
+ 		strcpy(*hp, options.https_proxy);
+ 		return KM_REMOTE_HTTPS;
+ 		}
+ 	else  {
+ 		return KM_LOCAL_HTTPS;
+ 		}
+ }
+ 
+ 
+ /*	Fake a response to local side's "CONNECT" message
+ **	by pushing remote side's "200 OK" message into the remote buffer.
+ **	The caller should prevent delivery of local side's "CONNECT" message
+ **	by purposefully failing to update local->ptr + num.
+ */
+ int 	fake_CONNECT(Channel *local)
+ {
+ 	if (writesocket(local->fd, connect_response,
+ 					strlen(connect_response)) < 0)  {
+ 		sockerror("fake_connect");
+ 		return 0;
+ 		}
+ 	return 1;
+ }
+ 
+ 
+ /*	Make new socket connection to host:port from CONNECT message.
+ **	Reset remote->fd from ssl fd to new fd.
+ **	Return 0:Success, -1:Problem
+ */
+ int 	create_remote_sock(Channel *remote, char *hostport)
+ {
+ 	struct sockaddr_in	addr;
+ 	int 				sock;
+ 	u_long				*host = NULL;
+ 	u_short				port;
+ #if defined FIONBIO && defined USE_NBIO
+ 	long				l;
+ #endif
+ 
+ 	if (!remote  ||  !hostport)  {
+ 		sockerror("create_remote_sock args");
+ 		return -1;
+ 		}
+ 
+ 	if ((sock = socket(AF_INET, SOCK_STREAM, 0)) < 0)  {
+ 		sockerror("remote hp socket");
+ 		return -1;
+ 		}
+ 
+ 	memset(&addr, 0, sizeof(addr));
+ 	addr.sin_family = AF_INET;
+ 	name2nums(hostport, &host, &port);
+ 	addr.sin_port = port;
+ 	addr.sin_addr.s_addr = *host;
+ 
+ 	if(!connect(sock, (struct sockaddr *) &addr, sizeof(addr)))  {
+ #if defined FIONBIO && defined USE_NBIO
+ 		l = 1; /* ON */
+ 		if(ioctlsocket(sock, FIONBIO, &l)<0)
+ 			sockerror("ioctlsocket (remote sock)"); /* non-critical */
+ 		log(LOG_DEBUG, "Remote socket set to non-blocking mode");
+ #endif
+ 		remote->fd  = sock;
+ 		return 0;		/* success */
+ 		}
+ 	else  {
+ 		sockerror("remote hp connect");
+ 		return -1;
+ 		}
+ }
+ 
+ 
  #ifndef NO_RSA
  static RSA *tmp_rsa_cb(SSL *s, int export, int keylength)
  { /* temporary RSA key callback */
***************
*** 556,565 ****
  {
      log(LOG_DEBUG, "%s", SSL_state_string_long(s));
      if(where==SSL_CB_HANDSHAKE_DONE)
!         print_stats();
  }
  
! static void print_stats() /* print statistics */
  {
      log(LOG_DEBUG, "%4ld items in the session cache",
          SSL_CTX_sess_number(ctx));
--- 1213,1222 ----
  {
      log(LOG_DEBUG, "%s", SSL_state_string_long(s));
      if(where==SSL_CB_HANDSHAKE_DONE)
!         print_stats(s->ctx);
  }
  
! static void print_stats(SSL_CTX *ctx) /* print statistics */
  {
      log(LOG_DEBUG, "%4ld items in the session cache",
          SSL_CTX_sess_number(ctx));
